const config = {
  menus: {
    'zh-cn': [
      {
        title: 'Omiu',
        list: [{ name: '简介', md: 'introduction' }]
      },
      {
        title: '基础元素',
        list: [
          { name: 'Button', md: 'button', demo: './repl/button.html' },
          { name: 'Icon', md: 'icon', demo: './repl/icon.html' }
        ]
      },
      {
        title: 'Layout',
        list: [
          { name: 'Row', md: 'row', demo: './repl/row.html' },
          {
            name: 'EqualSpace',
            md: 'equal-space',
            demo: './repl/equal-space.html'
          }
        ]
      },
      {
        title: '导航',
        list: [
          {
            name: 'Pagination',
            md: 'pagination',
            demo: './repl/pagination.html'
          },
          { name: 'Timeline', md: 'timeline', demo: './repl/timeline.html' },
          { name: 'Nav', md: 'nav', demo: './repl/nav.html' },
          { name: 'Tab', md: 'tab', demo: './repl/tab.html' },
          {
            name: 'DropdownMenu',
            md: 'dropdown-menu',
            demo: './repl/dropdown-menu.html'
          }
        ]
      },
      {
        title: '操作反馈',
        list: [
          {
            name: 'ActionSheet',
            md: 'action-sheet',
            demo: './repl/action-sheet.html'
          },
          { name: 'Toast', md: 'toast', demo: './repl/toast.html' },
          { name: 'Popup', md: 'popup', demo: './repl/popup.html' },
          { name: 'Dialog', md: 'dialog', demo: './repl/dialog.html' },
          { name: 'Popover', md: 'popover', demo: './repl/popover.html' }
        ]
      },
      {
        title: '表单',
        list: [
          { name: 'Input', md: 'input', demo: './repl/input.html' },
          {
            name: 'InputNumber',
            md: 'input-number',
            demo: './repl/input-number.html'
          },
          { name: 'Checkbox', md: 'checkbox', demo: './repl/checkbox.html' },
          { name: 'Radio', md: 'radio', demo: './repl/radio.html' },
          { name: 'Dropdown', md: 'dropdown', demo: './repl/dropdown.html' },
          { name: 'Switch', md: 'switch', demo: './repl/switch.html' },
          {
            name: 'DatePicker',
            md: 'date-picker',
            demo: './repl/date-picker.html'
          },
          { name: 'Rate', md: 'rate', demo: './repl/rate.html' },
          {
            name: 'SelectList',
            md: 'select-list',
            demo: './repl/select-list.html'
          }
        ]
      },
      {
        title: '数据展示',
        list: [
          { name: 'Table', md: 'table', demo: './repl/table.html' },
          {
            name: 'InputTable',
            md: 'input-table',
            demo: './repl/input-table.html'
          },
          { name: 'Badge', md: 'badge', demo: './repl/badge.html' },
          { name: 'Progress', md: 'progress', demo: './repl/progress.html' },
          {
            name: 'PathProgress',
            md: 'path-progress',
            demo: './repl/path-progress.html'
          },
          { name: 'Step', md: 'step', demo: './repl/step.html' }
        ]
      }
    ],
    en: [
      {
        title: 'Omiu',
        list: [{ name: 'Introduction', md: 'introduction' }]
      },
      {
        title: 'Base Element',
        list: [
          { name: 'Button', md: 'button', demo: './repl/button.html' },
          { name: 'Icon', md: 'icon', demo: './repl/icon.html' }
        ]
      },
      {
        title: 'Layout',
        list: [
          { name: 'Row', md: 'row', demo: './repl/row.html' },
          {
            name: 'EqualSpace',
            md: 'equal-space',
            demo: './repl/equal-space.html'
          }
        ]
      },
      {
        title: 'Navigation',
        list: [
          {
            name: 'Pagination',
            md: 'pagination',
            demo: './repl/pagination.html'
          },
          { name: 'Timeline', md: 'timeline', demo: './repl/timeline.html' },
          { name: 'Nav', md: 'nav', demo: './repl/nav.html' },
          { name: 'Tab', md: 'tab', demo: './repl/tab.html' },
          {
            name: 'DropdownMenu',
            md: 'dropdown-menu',
            demo: './repl/dropdown-menu.html'
          }
        ]
      },
      {
        title: 'Operational Feedback',
        list: [
          {
            name: 'ActionSheet',
            md: 'action-sheet',
            demo: './repl/action-sheet.html'
          },
          { name: 'Toast', md: 'toast', demo: './repl/toast.html' },
          { name: 'Popup', md: 'popup', demo: './repl/popup.html' },
          { name: 'Dialog', md: 'dialog', demo: './repl/dialog.html' },
          { name: 'Popover', md: 'popover', demo: './repl/popover.html' }
        ]
      },
      {
        title: 'Form',
        list: [
          { name: 'Input', md: 'input', demo: './repl/input.html' },
          {
            name: 'InputNumber',
            md: 'input-number',
            demo: './repl/input-number.html'
          },
          { name: 'Checkbox', md: 'checkbox', demo: './repl/checkbox.html' },
          { name: 'Radio', md: 'radio', demo: './repl/radio.html' },
          { name: 'Dropdown', md: 'dropdown', demo: './repl/dropdown.html' },
          { name: 'Switch', md: 'switch', demo: './repl/switch.html' },
          {
            name: 'DatePicker',
            md: 'date-picker',
            demo: './repl/date-picker.html'
          },
          { name: 'Rate', md: 'rate', demo: './repl/rate.html' },
          {
            name: 'SelectList',
            md: 'select-list',
            demo: './repl/select-list.html'
          }
        ]
      },
      {
        title: 'Data',
        list: [
          { name: 'Table', md: 'table', demo: './repl/table.html' },
          {
            name: 'InputTable',
            md: 'input-table',
            demo: './repl/input-table.html'
          },
          { name: 'Badge', md: 'badge', demo: './repl/badge.html' },
          { name: 'Progress', md: 'progress', demo: './repl/progress.html' },
          {
            name: 'PathProgress',
            md: 'path-progress',
            demo: './repl/path-progress.html'
          },
          { name: 'Step', md: 'step', demo: './repl/step.html' }
        ]
      }
    ]
  }
}

export default config
